﻿/*
    
версия 2.0
Теперь в ячейке с заменой может находиться более одного символа.
    
Скрипт может помочь везде, где нужно заменить ключевые слова на содержимое буфера обмена.
1. Создайте фрейм со списком автозамен (используйте GREP!):
   а. В виде таблицы: | Выражение GREP  | Объект, вставленный в текст, текст или и то и другое |
   б. В виде списка с разделителем-табом: Выражение GREP[tab]| Объект, вставленный в текст, текст или и то и другое |
2. Выделите фрейм со списком автозамен, затем, зажав shift, выделите фрейм, в котором вы хотите произвести замены, и запустите скрипт.
   Если будет выбран только один фрейм, скрипт сработает для всего документа.
   
   Ссылка на демо-видео: https://youtu.be/60NRzN0k_Sw
   
   by Alexey Stukun st_verstka@mail.ru
*/

if (app.documents.length == 0) {
    myExit("Нет открытого документа для работы.");
  }
if (!app.activeDocument.saved) {
    myExit("Сохраните документ где-нибудь и попробуйте ещё раз.");
}
if (app.selection.length == 0) {
  myExit("READ ME\nВыделите фрейм со списком автозамен, затем, зажав shift, выделите фрейм, в котором вы хотите произвести замены, и запустите скрипт. Если будет выбран только один фрейм, скрипт сработает для всего документа.");
  }

var myDoc = app.activeDocument;
var dataFrame = app.selection[0];
var dataStory = dataFrame.parentStory;

if (app.selection.length > 1) {
    var workArea = app.selection[1].parentStory;
    } else {
        var workArea = myDoc;
        }
// Превращаем ваш список в таблицу:
if (dataFrame.tables.length == 0) {
    dataStory.texts[0].convertToTable();
}
var dataTable = dataFrame.tables[0];

// Перебираем строки таблицы:
for (i = 0, iLen = dataTable.rows.length; i < iLen; i++) {
    
    var myRow = dataTable.rows[i];
    var myFindWhat = myRow.cells[0].contents;
    
    try {
        selectChars();
        app.copy();
        } catch(error) {
            continue;
    }

    // Настройки поиска:
    app.findGrepPreferences = app.changeGrepPreferences = null;
    app.findGrepPreferences.findWhat = myFindWhat;
    try {
        var myFounds = workArea.findGrep();
        } catch (error) { 
            continue;
    }
    app.findGrepPreferences = app.changeGrepPreferences = null;
    
    if (myFounds.length == 0) {
        continue;
    }

    for (t = 0, tLen = myFounds.length; t < tLen; t++) {
        if (myFounds[t].parent.parent.parent == dataFrame) {
            continue;
        }
        myFounds[t].select();
        app.paste();
    }
}

function myExit(message) {
      alert(message);
      exit();
}

function selectChars() {
    myRow.cells[1].characters[0].select();
    for (c = 1, cLen = myRow.cells[1].characters.length; c < cLen; c++) {
        myRow.cells[1].characters[c].select(SelectionOptions.addTo);
        }
}